



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Asp.net有关访问页面权限的限制和错误页面配置</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Asp.net有关访问页面权限的限制和错误页面配置</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 15:39:22 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>一、访问页面权限的限制</h2>
<p>一个小项目，涉及到用户登录。</p>
<p>在用户没登录访问内容也时，对页面做一定限制，没登录的则不能访问，直接跳转到登录界面。</p>
<div>
<pre class="prettyprint linenums">    /// &lt;summary&gt;<br />
    /// 对没有登录用户，访问需要登录页面做限制<br />
    /// 思路：判断Session中是否有userInfo的信息没有则跳转到登录页面<br />
    /// 方案：1，自定义一个类，继承System.Web.UI.Page，然后重写Page_Init方法<br />
    ///      2，每个page加载的时候都会调用Page_Init的，所以再让其他Page继承SessionLogin<br />
    /// &lt;/summary&gt;<br />
    public class SessionLogin:System.Web.UI.Page<br />
    {<br />
        public void Page_Init(object sender, EventArgs e)<br />
        {<br />
            if (Session["userInfo"]==null)<br />
            {<br />
                Response.Redirect(@".\Login.aspx");<br />
            }<br />
        }<br />
    }</pre>
</div>
<p>要加权限的页面：</p>
<div>
<pre class="prettyprint linenums">    //直接继承SessionLogin，由于SessionLogin继承了System.Web.UI.Page<br />
    public partial class AdminIndex : SessionLogin<br />
    {<br />
        protected void Page_Load(object sender, EventArgs e)<br />
        {

        }<br />
    }</pre>
</div>
<h2>二、错误页面的配置</h2>
<p>用户在访问时系统可能出现错误，直接把错误界面展示给用户是很不礼貌的</p>
<p>所以做一个错误界面还是很有必要的，配置方法也是比较简单的</p>
<p>Web.config的配置</p>
<div>
<pre class="prettyprint linenums">&lt;configuration&gt;<br />
    &lt;system.web&gt;<br />
      &lt;!--On总是显示错误页面，Off不显示错误页面，ReomteOnly服务端不显示，客户端显示--&gt;<br />
      &lt;customErrors mode="On" defaultRedirect="./error/error.html"&gt;<br />
        &lt;error statusCode="403" redirect="./error/error.html"/&gt;<br />
        &lt;error statusCode="404" redirect="./error/error.html"/&gt;<br />
      &lt;/customErrors&gt;

      &lt;compilation debug="true" targetFramework="4.0" /&gt;<br />
    &lt;/system.web&gt;

    &lt;connectionStrings&gt;<br />
      &lt;add name="sqlstr"  connectionString="server=.;uid=sa;pwd=123456;database=db_NetStore"/&gt;<br />
    &lt;/connectionStrings&gt;

&lt;/configuration&gt;</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/877187/201611/877187-20161125195402409-504490191.jpg" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvme3xq.html">一个php soap的错误记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1mldz9.html">iOS七大手势之&lpar;平移、捏合、轻扫、屏幕边缘轻扫&rpar;手势识别器方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd4n7k8.html">关于Azure存储账户中存储虚拟机VHD文件的注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd3r7r8.html">生意经：研究一下国外SAAS的产品线，比如Salesforce、Netsuite和Zendesk等等（Salesforce斥资7&period;5亿美元收购云计算字处理应用Quip）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z02j59.html">java学习笔记day04</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd6d0l8.html">Z&period;Studio高级成衣定制&lpar;双井店&rpar;价格&comma;地址&lpar;图&rpar;-北京-大众点评网</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok7me19.html">Linux学习之head命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1km2o69.html">Ｗeb Application的目录结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojjkvpq.html">Oracle SQL Lesson &lpar;2&rpar; - 限制和排序数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/950pzzv8.html">使用SQL Server 2000索引视图提高性能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy14gemq.html">MS SQL Server数据库修复&sol;MDF数据文件数据恢复&sol;MDF质疑&sol;mdf无法附加</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg1vy48.html">STL的空间配置器std&lowbar;alloc 笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z023k9.html">2016-2017 ACM-ICPC&comma; Asia Tsukuba Regional Contest  D Hidden Anagrams</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zopxmvq.html">原生JS封装时间运动函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/960ond39.html">sql，求和小于一定值的数据行</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvleel8.html">【CQOI2011】放棋子</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy4mmx9.html">SpringBoot系统列 3 - 多线程数据处理&lpar;ThreadPoolTaskExecutor、DruidDataSource&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwljyw39.html">微信小程序表单校验WxValidate&period;js使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vrm2zq.html">C&num;判断网站是否能访问或者宕机的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpgd4z9.html">Python学习-27&period;Python中的列表（list）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m8zr7gdq.html">Firebug 学习使用教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/495m1jzq.html">JavaScript笔记 Function</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1px60q.html">省市联动sql脚本</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqln3n08.html">mybatis研究：select性能对比</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ov035q.html">linux 时间管理&mdash;&mdash;概念、注意点&lpar;一&rpar;【转】</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ovejxq.html">HTML纯javaScript代码写图片轮播</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8ml1x69.html">解决项目中&period;a文件的冲突</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2mod38.html">android学习计划2</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlng508.html">GDUFE-OJ  1203x的y次方的最后三位数  快速幂</a>
			</li>
						<li><a href="https://www.batexi.com/a/495m56eq.html">Creating Dialogs</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
